﻿local VERSION = tonumber(("$Revision: 42095 $"):match("%d+"))

local QuestsFu = QuestsFu
local QuestsFu_Tooltips = QuestsFu:NewModule("Tooltips", "AceEvent-2.0", "AceHook-2.1", "AceConsole-2.0")
if QuestsFu.revision < VERSION then
	QuestsFu.version = "r" .. VERSION
	QuestsFu.revision = VERSION
	QuestsFu.date = ("$Date: 2007-06-28 14:34:19 -0400 (Thu, 28 Jun 2007) $"):match("%d%d%d%d%-%d%d%-%d%d")
end

local quixote = AceLibrary("Quixote-1.0")
local crayon = AceLibrary("Crayon-2.0")

local L = AceLibrary("AceLocale-2.2"):new("QuestsFu_Tooltips")
L:RegisterTranslations("enUS", function() return {
	["Tooltips"] = true,
	["Show quest objectives in item/mob tooltips"] = true,
} end)

L:RegisterTranslations("deDE", function() return {
	["Tooltips"] = "Tooltips",
	["Show quest objectives in item/mob tooltips"] = "Zeige Quest-Ziele im Item/Mob Tooltip.",
} end)

L:RegisterTranslations("koKR", function() return {
	["Tooltips"] = "툴팁",
	["Show quest objectives in item/mob tooltips"] = "툴팁에 퀘스트 몹/아이템을 표시합니다.",
} end)

L:RegisterTranslations("zhTW", function() return {
	["Tooltips"] = "提示訊息",
	["Show quest objectives in item/mob tooltips"] = "在物品/怪物提示訊息中顯示任務目標",
} end)

L:RegisterTranslations("esES", function() return {
	["Tooltips"] = "Tooltips",
	["Show quest objectives in item/mob tooltips"] = "Muestra los objetivos de misión en los tooltip de objetos/enemigos",
} end)

function QuestsFu_Tooltips:OnInitialize()
	self.db = QuestsFu:AcquireDBNamespace("Tooltips")
	QuestsFu:RegisterDefaults("Tooltips", "profile", {
	})
	QuestsFu.options.args.Tooltips = {
		name = L["Tooltips"],
		desc = L["Show quest objectives in item/mob tooltips"],
		type = 'toggle',
		get = function() return QuestsFu:IsModuleActive(self) end,
		set = function() QuestsFu:ToggleModuleActive(self) end,
	}
end

function QuestsFu_Tooltips:OnEnable()
	self:HookScript(GameTooltip, "OnTooltipSetItem")
	self:HookScript(GameTooltip, "OnTooltipSetUnit")
end

function QuestsFu_Tooltips:OnTooltipSetUnit(tooltip, ...)
	if quixote:IsQuestMob(tooltip:GetUnit()) then
		for _,q,i,n in quixote:IterateQuestsForMob(tooltip:GetUnit()) do
			GameTooltip:AddDoubleLine(q, i..'/'..n, 1, 1, 1, crayon:GetThresholdColor(i/n))
		end
	end
	return self.hooks[tooltip].OnTooltipSetUnit(tooltip, ...)
end

function QuestsFu_Tooltips:OnTooltipSetItem(tooltip, ...)
	local t = tooltip:GetItem()
	if t then
		local q,i,n = quixote:IsQuestItem(t)
		if q then
			tooltip:AddDoubleLine(q, i..'/'..n, 1, 1, 1, crayon:GetThresholdColor(i/n))
		end
	end
	return self.hooks[tooltip].OnTooltipSetItem(tooltip, ...)
end
